-- >>> [x+y | x <- [1..4], y <- [2..4], x>y]
-- [5,6,7]
--

-- >>> divisor x = [y | y <- [1..x], (x `mod` y == 0)]
-- >>> divisor 12
-- [1,2,3,4,6,12]
--

-- >>> quickSort xs = [y | y <- xs, x <- xs, y<x]
-- >>> quickSort [2,1,3]
-- [2,1,1]
--

-- >>> quickSort2 [] = []
-- >>> quickSort2 (x:xs) = quickSort2 [y | y <- xs, y <= x] ++ [x] ++ quickSort2 [y | y <- xs, y>x]
-- <interactive>:2740:2-19: warning: [-Wincomplete-patterns]
--     Pattern match(es) are non-exhaustive
--     In an equation for ‘quickSort2’: Patterns not matched: (_:_)
-- <BLANKLINE>
-- <interactive>:2741:2-90: warning: [-Wincomplete-patterns]
--     Pattern match(es) are non-exhaustive
--     In an equation for ‘quickSort2’: Patterns not matched: []
--

