multSumByFive a b = simple 5 a b 
simple n a b = n * (a+b)

reverses xs = foldl revOp [] xs
  where revOp acc x = x:acc

succ_ = \x -> x+1

-- learn about currying 

f n = (\m -> n + m)
-- g = f 10; that means we init n with value of 10
-- g 3 ; will return 13 


-- find max with foldr
maxList [] = 0
maxList (x:xs) = foldr maximus x xs
 where maximus a b | a >= b = a | otherwise = b


-- find kpk
kpk a b = ([ x*y | x <- [1..a*b], y<- [1..a*b], x*y `mod`a==0, x*y`mod`b==0])!! 0

-- concat
exercise xs ys = (map (\x -> map (\y -> (x,y)) ys) xs)
-- result : [(4,1),(4,2),(4,4),(5,1),(5,2),(5,4)]

-- mergesort
-- 1. array splits into two
-- 2. mergesort both
-- 3. merge both array that has been merged
merge [] kanan                          = kanan
merge kiri []                           = kiri
merge kiri@(x:xs) kanan@(y:ys) | x < y  = x: merge xs kanan
                               | y <= x = y: merge kiri ys

mergeSort xs = merge (mergeSort kiri) (mergeSort kanan)
  where kiri = take ((length xs) `div` 2) xs 
        kanan = drop ((length xs) `div` 2) xs
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   