{-# LANGUAGE CPP #-}
{-# LANGUAGE NoRebindableSyntax #-}
{-# OPTIONS_GHC -fno-warn-missing-import-lists #-}
module Paths_pemfung (
    version,
    getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir,
    getDataFileName, getSysconfDir
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
import Prelude

#if defined(VERSION_base)

#if MIN_VERSION_base(4,0,0)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#else
catchIO :: IO a -> (Exception.Exception -> IO a) -> IO a
#endif

#else
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#endif
catchIO = Exception.catch

version :: Version
version = Version [0,1,0,0] []
bindir, libdir, dynlibdir, datadir, libexecdir, sysconfdir :: FilePath

bindir     = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/bin"
libdir     = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/lib/x86_64-osx-ghc-8.6.5/pemfung-0.1.0.0-AkKFGsU77g9E8FsNyy33N7-pemfung-exe"
dynlibdir  = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/lib/x86_64-osx-ghc-8.6.5"
datadir    = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/share/x86_64-osx-ghc-8.6.5/pemfung-0.1.0.0"
libexecdir = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/libexec/x86_64-osx-ghc-8.6.5/pemfung-0.1.0.0"
sysconfdir = "/Users/zulia/Documents/pemfung/functional-programming/.stack-work/install/x86_64-osx/8b85e9eb2440c2b61b87f1fb681959c2b20ea41e402d4a89851b6d3544997ce8/8.6.5/etc"

getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir, getSysconfDir :: IO FilePath
getBinDir = catchIO (getEnv "pemfung_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "pemfung_libdir") (\_ -> return libdir)
getDynLibDir = catchIO (getEnv "pemfung_dynlibdir") (\_ -> return dynlibdir)
getDataDir = catchIO (getEnv "pemfung_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "pemfung_libexecdir") (\_ -> return libexecdir)
getSysconfDir = catchIO (getEnv "pemfung_sysconfdir") (\_ -> return sysconfdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
